## t4kcommon 0.1.1

=== CMakeLists.txt ===
#This script was sloppily frankensteined from a handful of tux4kids'
#other CMakeLists.txt and is not safe for human consumption. 
#Please hack responsibly.

cmake_minimum_required(VERSION 2.6)

set(PACKAGE_NAME "Tux4Kids_common")
set(PACKAGE_VERSION 0.1.1)
set(T4K_COMMON_PACKAGE_STRING "${PACKAGE_NAME}-${PACKAGE_VERSION}" )
set(LIB_NAME "t4k_common")
project(${PACKAGE_NAME})

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake-modules")
include(T4K_Sugar)

set(SDL_BUILDING_LIBRARY 1) #indicate we don't need to (and shouldn't) link SDLmain

set(T4K_DEVELOPER_WARNINGS OFF CACHE STRING "Change or override to enable warnings")
if(CMAKE_BUILD_TYPE MATCHES Release)
  set(T4K_DEVELOPER_WARNINGS ON)
endif()

find_package(SDL REQUIRED)
find_package(SDL_image REQUIRED)
find_package(SDL_mixer REQUIRED)
find_package(SDL_Pango)
if (SDLPANGO_FOUND)
	set(HAVE_LIBSDL_PANGO 1)
else (SDLPANGO_FOUND)
  find_package(SDL_ttf REQUIRED) # we prefer Pango but use SDL_ttf as a backup
endif (SDLPANGO_FOUND)

# needed for SVG loading and caching
find_package(PNG)
find_package(RSVG)
set(HAVE_RSVG RSVG_FOUND)
set(HAVE_LIBPNG PNG_FOUND)
find_package(SDL_net)
set(HAVE_LIBSDL_NET SDL_net_FOUND)

message("SDL_Pango:  ${SDLPANGO_FOUND}")



# based on tuxmath's CMakeLists.txt
if (APPLE)
  set(MACOSX_BUNDLE_NAME ${PACKAGE_NAME})
  set(DATA_PREFIX
      ${T4K_COMMON_MACOSX_BUNDLE_NAME}.app/Contents/Resources)
elseif(UNIX)
  set (DATA_PREFIX
      ${CMAKE_INSTALL_PREFIX}/share/${LIB_NAME})
elseif(WIN32)
  t4k_to_unix_path(DATA_PREFIX "\$ENV{APPDATA}/${PACKAGE_NAME}")
else()
  message(SEND_ERROR "What OS are you on?")
endif()

set(LINEBREAK_BINARY_DIR ${CMAKE_BINARY_DIR}/src/linebreak)
set(LINEBREAK_SOURCE_DIR ${CMAKE_SOURCE_DIR}/src/linebreak)

#process subdirectories
add_subdirectory(src)
add_subdirectory(data)

include(CPack)

# FIXME - below are "dumb" assignments to the variables
# required for t4k_common.pc.in to generate a working t4k_common.pc
# We should make these variables reflect what libs we actually found,
# particularly SDL_Pango vs. SDL_ttf - DSB
set(DEP_PKGS "sdl >= 1.2.0 SDL_image SDL_Pango librsvg-2.0 libxml-2.0") 
set(DEP_LIBS "-lSDL_mixer -lSDL_net") 
set(DEP_LIBS_PRIVATE "-mwindows -lmikmod -lsmpeg -lstdc++ -lmingw32 -lSDLmain -liconv -luser32 -lgdi32 -lwinmm -ldxguid -lSDL -lpthread -lvorbisfile -lvorbis -lm -logg -lfreetype")

=== data/CMakeLists.txt ===
include (T4K_Sugar)

t4k_gentle_set(DESTDIR "${DATA_PREFIX}")

install (DIRECTORY images
    DESTINATION ${DESTDIR}
    PATTERN Makefile* EXCLUDE
    PATTERN .svn EXCLUDE
    PATTERN CMakeLists.txt EXCLUDE
    PATTERN *~ EXCLUDE )

=== src/CMakeLists.txt ===
#This script was sloppily frankensteined from a handful of tux4kids'
#other CMakeLists.txt and is not safe for human consumption. 
#Please hack responsibly.

cmake_minimum_required(VERSION 2.6)

include(ConfigureChecks)
configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
include(T4K_Sugar)

find_package(LibXml2 REQUIRED)

#Look here for headers
include_directories(
  ${SDL_INCLUDE_DIR}
  ${SDLIMAGE_INCLUDE_DIR}
  ${SDLMIXER_INCLUDE_DIR}
  ${LIBXML2_INCLUDE_DIR}
  ${CMAKE_SOURCE_DIR}/gettext
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_BINARY_DIR}/gettext
  ${CMAKE_BINARY_DIR}/src/linebreak
  ${CMAKE_SOURCE_DIR}/src/linebreak
)

#Look here for optional headers
t4k_include_directory(SDLPANGO)
t4k_include_directory(SDLTTF)
t4k_include_directory(PNG)
t4k_include_directory(RSVG)

#include_directories( ${T4KCOMMON_INCLUDE_DIRS} )

set( T4K_COMMON_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} )
if(T4K_DEVELOPER_WARNINGS)
  list(APPEND CMAKE_C_FLAGS -Wall) 
endif()

#Find source files
file(GLOB_RECURSE T4K_COMMON_SOURCES ${T4K_COMMON_SOURCE_DIR}/*.c)
file(GLOB_RECURSE T4K_COMMON_HEADERS ${T4K_COMMON_SOURCE_DIR}/*.h)

#Declare the library as a SO 
add_library( ${LIB_NAME} SHARED
	${T4K_COMMON_SOURCES} ${T4K_COMMON_HEADERS} )

#Avoid linking to both libraries
if(SDLPANGO_FOUND)
    set(SDLTTF_LIBRARY "")
else()
    set(SDLPANGO_LIBRARY "")
endif()

#Depend on these libraries. For Pango or TTF, whichever is found will be used
target_link_libraries(${LIB_NAME}
	${SDL_LIBRARY}
	${SDLMIXER_LIBRARY}
	${SDLIMAGE_LIBRARY}
	${SDLPANGO_LIBRARY}
	${SDLTTF_LIBRARY}
        ${LIBXML2_LIBRARIES}
        ${LINEBREAK_BINARY_DIR}/liblinebreak.a
)

t4k_include_definition(HAVE_LIBSDL_PANGO)
t4k_include_definition(HAVE_LIBPNG)
set_target_properties (${LIB_NAME} PROPERTIES 
	COMPILE_FLAGS "${_rsvg_def} ${_pango_def} ${_rsvg_cflags} ${_cairo_cflags}"
	COMPILE_DEFINITIONS
	"COMMON_DATA_PREFIX=\"${DATA_PREFIX}\";USE_T4K_PREFIX=1;PACKAGE_STRING=\"${PACKAGE_NAME}\""
	LINK_INTERFACE_LIBRARIES ""
)

add_dependencies(${LIB_NAME} linebreak)

install( TARGETS ${LIB_NAME}
	DESTINATION lib )

install(FILES ${T4K_COMMON_SOURCE_DIR}/t4k_common.h
	      ${T4K_COMMON_SOURCE_DIR}/t4k_alphasort.h
	      ${T4K_COMMON_SOURCE_DIR}/t4k_scandir.h
	DESTINATION include)

include(UseDoxygen OPTIONAL)

#process subdirectories
add_subdirectory(linebreak)

=== src/linebreak/CMakeLists.txt ===
# Build script for the "linebreak" library, which provides the
#"linebreak" utilities from libgettextpo
#
# Timothy E. Holy, 2009

# If you're building this as part of a larger package, the following
# variables can be set upon entry:
#   LINEBREAK_BINARY_DIR
#   LINEBREAK_SOURCE_DIR
#   LOCALE_DIR
#   TOP_SRC_DIR
#   PREFIX
project(linebreak)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)
include(CheckFunctionExists)
include(T4K_Sugar)
# If not found, we use SDL_iconv instead
find_package(Iconv)
#message("Iconv const: ${ICONV_SECOND_ARGUMENT_IS_CONST}")
set(HAVE_ICONV ${ICONV_FOUND})
t4k_include_definition(HAVE_ICONV)
# This can either be called in standalone mode, or as part of a larger
# project.  For that reason, we need to examine whether certain settings
# have been made before, or not.

# Removed the conditional since ConfigureChecksIntl 
# guards itself with INTL_CHECKS_DONE, is that okay? -BML
include(ConfigureChecksIntl)
t4k_gentle_set(LINEBREAK_BINARY_DIR ${CMAKE_BINARY_DIR})
t4k_gentle_set(LINEBREAK_SOURCE_DIR ${CMAKE_SOURCE_DIR})

# Generate the appropriate config.h file
configure_file(linebreak_config.h.cmake ${LINEBREAK_BINARY_DIR}/config.h)
add_definitions(
    -DHAVE_CONFIG_H=1
    -DMAKE_LINEBREAK_LIB
    -DIN_LIBLINEBREAK
    -DENABLE_RELOCATABLE=1
    -DIN_LIBRARY
    -DNO_XMALLOC
    -Dset_relocation_prefix=liblinebreak_set_relocation_prefix
    -Drelocate=liblinebreak_relocate
    -DDEPENDS_ON_LIBICONV=1
    )
    
if (APPLE)
set_directory_properties(PROPERTIES COMPILE_DEFINITIONS
	LOCALEDIR='\"${LOCALE_DIR}\"'        	
	LOCALE_ALIAS_PATH='\"${LOCALE_DIR}\"'
	LIBDIR='\"${TOP_SRC_DIR}\"'
	INSTALLDIR='\"${PREFIX}\"' 
	)
add_definitions(
		-DLOCALEDIR='\"${LOCALE_DIR}\"' 
		-DLOCALE_ALIAS_PATH='\"${LOCALE_DIR}\"'
		-DLIBDIR='\"${TOP_SRC_DIR}\"'
		-DINSTALLDIR='\"${PREFIX}\"' 
		)
else (APPLE)
add_definitions(
		-DLOCALEDIR=\\"${LOCALE_DIR}\\" 
		-DLOCALE_ALIAS_PATH=\\"${LOCALE_DIR}\\"
		-DLIBDIR=\\"${TOP_SRC_DIR}\\"
		-DINSTALLDIR=\\"${PREFIX}\\" 
		)
endif (APPLE)

file(GLOB_RECURSE LINEBREAK_HEADERS ${LINEBREAK_SOURCE_DIR} *.h)
file(GLOB_RECURSE LINEBREAK_SOURCES ${LINEBREAK_SOURCE_DIR} *.c)

include_directories(
  ${LINEBREAK_BINARY_DIR} 
  ${LINEBREAK_SOURCE_DIR} 
  ${CMAKE_CURRENT_BINARY_DIR})
  
if (ICONV_FOUND)
  include_directories(${ICONV_INCLUDE_DIR})
  target_link_libraries(linebreak ${ICONV_LIBRARY})
endif (ICONV_FOUND)
add_library(linebreak STATIC ${LINEBREAK_SOURCES} ${LINEBREAK_HEADERS})

#project_source_group("${GROUP_CODE}" LINEBREAK_SOURCES LINEBREAK_HEADERS)

=== debian/changelog ===
t4kcommon (0.1.1-3) unstable; urgency=medium

  * Bump Standards-Version to 4.1.1, no changes needed.
  * Bump debian/compat to 10 and build-depend on debhelper >= 10.2.5~ and
    remove --parallel from dh call in debian/rules as this is the default with
    compat 10. Similarly remove dh-autoreconf from build-depends and remove
    --autoreconf from dh call as well.

 -- Holger Levsen <holger@debian.org>  Sat, 30 Sep 2017 00:19:19 +0200

t4kcommon (0.1.1-2) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * Upgrade Vcs-Browser URL.

  [ Holger Levsen ]
  * Acknowledge NMU, thanks Tobias.
  * Bump standards version to 3.9.8, no changes needed. 
  * Use git instead of cgit in Vcs-Browser URL.

 -- Holger Levsen <holger@debian.org>  Thu, 29 Sep 2016 14:02:09 +0200

t4kcommon (0.1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "FTBFS against new libpng1.6 API. Patch from BTS (Closes: #743388)
  * Add explicit B-D against libpng-dev (to avoid that we miss it again the
    next transition)

 -- Tobias Frost <tobi@debian.org>  Thu, 07 Apr 2016 21:11:17 +0200

t4kcommon (0.1.1-1) unstable; urgency=low

  [ Dmitry Smirnov ]
  * Preparing for release (Closes: #718631).

  [ Holger Levsen ]
  * Initial release, needed for new tuxmath version. Will in future also
    be used for tuxtype.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 20 Nov 2013 13:14:21 +1100

=== debian/control ===
Source: t4kcommon
Section: libs
Priority: optional
Maintainer: Holger Levsen <holger@debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 10.2.5~), autopoint
              ,doxygen
              ,libpng-dev
              ,librsvg2-dev
              ,libsdl-pango-dev
              ,libsdl-image1.2-dev
              ,libsdl-mixer1.2-dev
              ,libsdl-net1.2-dev
              ,libxml2-dev
# needed for de-duplication:
              ,rdfind ,symlinks
Standards-Version: 4.1.1
Homepage: http://tux4kids.alioth.debian.org/
Vcs-Git: git://anonscm.debian.org/tux4kids/t4kcommon.git
Vcs-Browser: https://anonscm.debian.org/git/tux4kids/t4kcommon.git

Package: libt4k-common0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: common library for tux4kids
 t4k_common is a library of code shared between tuxmath and tuxtype.

Package: libt4k-common0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libt4k-common0 (= ${binary:Version})
              ,librsvg2-dev
              ,libsdl-pango-dev
              ,libsdl-image1.2-dev
              ,libxml2-dev
#Suggests: libt4k-common0-doc
Description: common library for tux4kids - development files
 t4k_common is a library of code shared between tuxmath and tuxtype.
 .
 This package contains the development flies.

#Package: libt4k-common0-doc
#Section: doc
#Architecture: all
#Multi-Arch: foreign
#Depends: ${misc:Depends}, libjs-jquery
#Suggests: libt4k-common0-dev
#Description: common library for tux4kids - documentation
# t4k_common is a library of code shared between tuxmath and tuxtype.
# .
# This package contains the HTML documentation.

#Package: libt4k-common0-dbg
#Section: debug
#Priority: extra
#Architecture: any
#Multi-Arch: same
#Depends: ${misc:Depends}, libt4k-common0 (= ${binary:Version})
#Description: common library for tux4kids - debugging symbols
# t4k_common is a library of code shared between tuxmath and tuxtype.
# .
# This package provides debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKG=libt4k-common0

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND= -Wl,--as-needed

%:
	dh $@

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -r doxygen

doxygen/html:
	doxygen -u && doxygen
	# De-duplication:
	rdfind -outputname /dev/null -makesymlinks true doxygen
	symlinks -rsc doxygen

override_dh_installdocs: doxygen/html
	dh_installdocs -p$(PKG)-dev --link-doc=$(PKG)
	dh_installdocs

override_dh_strip:
	[ -d "$(CURDIR)/debian/$(PKG)-dbg" ] \
        && dh_strip --dbg-package=$(PKG)-dbg \
        || dh_strip

override_dh_builddeb:
	dh_builddeb -- -Zxz

=== debian/watch ===
version=3

# devscripts/uscan [2.12.6, 2.13.2] are affected by #712261: "406 Not Acceptable"

 http://alioth.debian.org/frs/?group_id=31080 \
  .*/t4k_common-([0-9.]+)\.tar\.(?:gz|bz2|xz)
